// "clsDraw3DTexBoxA.cpp"

#ifndef _DRAW_3DTEXBOX_B_H_
#define _DRAW_3DTEXBOX_B_H_

#include "clsDraw3DTexBoxA.h"
#include "../../MYGL/clsPositionAndDirection.h"

#if WIN32
#include <windows.h>
#endif

#ifndef TRUE
#define TURE true
#define FALSE false
#endif

#include <vector>

class PreviewProperty_cls;
//class DF3Sequence_cls;
class DF3SeqCtrl_cls;

class Draw3DTexBoxB_cls : public DrawDataBoxBase_cls {
 public:
    Draw3DTexBoxB_cls(DF3SeqCtrl_cls *pCDF3SeqCtrl, 
		      PreviewProperty_cls *pCProperty);
    
    static void DrawSlice3DX(double coord, 
			     double sMin, double sMax, double tMin, double tMax,
			     double *pShadeOffset);
    static void DrawSlice3DY(double coord, 
			     double sMin, double sMax, double tMin, double tMax,
			     double *pShadeOffset);
    static void DrawSlice3DZ(double coord, 
			     double sMin, double sMax, double tMin, double tMax,
			     double *pShadeOffset);
    static void (*mspFuncDrawSlice3D[3])
	(double coord, double sMin, double sMax, double tMin, double tMax,
	 double *pShadeOffset);
    
    void DrawSlice3DMain(unsigned int axis, double sizeAxis, int index,
			 double sMin, double sMax, double tMin, double tMax,
			 float clr[3], float clrinv[3], 
			 float alpha, double *pShadeOffset);

    void DrawSlice3D(unsigned int axis, double sizeAxis, bool order,
		     float clr[3], float clrinv[3], 
		     double clipBoxMin[3], double clipBoxMax[3], float alpha,
		     double *pShadeOffset);
    void DrawSlice3DWithOtherGL
	(unsigned int axis, int indexNum, double sizeAxis, bool order,
	 float (*clr)[3], float (*clrinv)[3], int *Atexture3D,
	 double clipBoxMin[3], double clipBoxMax[3], double *Aalpha,
	 double *pShadeOffset);
    
};

#endif
