
#include "clsFilterCtrl.h"
#include "clsFilterWithParameter.h"
#include "../DF3/clsDF3SeqGUI.h"
#include "../PARAMETER/clsParameters.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"

#include "../MYAPI/MsgBox.h"

FilterWithParameterData_cls::
FilterWithParameterData_cls(FilterCtrl_cls *pCParentCtrl){
    mpCCtrl = pCParentCtrl;
}

double* FilterWithParameterData_cls::
GetPInterpolated(){
    return GetPParamActive()->mpInterpolatedValue; 
}

// -----------

FilterWithParameter_cls::
FilterWithParameter_cls(FilterCtrl_cls *pCParentCtrl) :
    FilterBase_cls(pCParentCtrl) {
    mbWithParameter = TRUE;
    mpCParamPanel = NULL;
}

FilterWithParameter_cls::
~FilterWithParameter_cls(){
    delete mpCData;
}

FilterData_cls* FilterWithParameter_cls::
GetPData(){
    return mpCData;
}

void FilterWithParameter_cls::
ConnectParameterToTL(){
    mpCParamPanel = mspCDF3SeqGUI->mpCPanelList->
	Add(mpCData->GetPParamActive(), mpCData->mCstrCustomName.msBody);
    mspCDF3SeqGUI->ConnectMouseEvent();
    //mspCDF3SeqGUI->UpdatePanelLayout();
    //wxSizeEvent com;
    //mspCDF3SeqGUI->AddPendingEvent(com);
}

void FilterWithParameter_cls::
SetParam(int index, double value){
    mpCData->GetPParamActive()->mpInterpolatedValue[index] = value;
    mpCData->GetPParamActive()->SetKeyIfChanged();
}

void FilterWithParameter_cls::
SetKeyIfChanged(double doubleIndex){
    mpCData->GetPParamActive()->SetKeyIfChanged(doubleIndex);
}

void FilterWithParameter_cls::
UpdateParameters(double doubleIndex){
    mpCData->GetPParamActive()->GetPInterpolatedValue(doubleIndex);
    mpCGUIPanel->mpCMNumPanel->UpdateValuesAll(TRUE); 
}
