// -*- c -*- 
// (setq c-basic-offset 4)
// ("GLOBJGridFlat.h")

#include <math.h>

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include "GLOBJGridFlat.h"

namespace GLOBJ {
    /*!
      @brief ʃObh[-1:+1],[-1:+1]̕`
      @param[in] fineness ׂ
      @param[in] iMode `惂[h
      @param[out] VKfBXvCXgԍ
    */
    int GridFlat::DListDraw(int fineness, int iMode,
			    bool zAxis, bool omitCenter,
			    bool omitBoundingFrame){
	if (fineness < 3) fineness = 3;
	
	int    listName = 0;
  	// TEXTURE̊͂Őݒ肵ĂӖ 
	// ł́AWƃeNX`̈ʒu֌Ŵ݂^ 
  	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE){
	    listName = glGenLists(1); // VKXg̔ԍ
	    glNewList (listName, iMode); 
	}

	for (int i= -fineness + (int)omitBoundingFrame
		 ; i <= fineness - (int)omitBoundingFrame
		 ; i++){
	    if (omitCenter && i == 0) continue;
	    
	    float value = (float)i / fineness;
	    glBegin(GL_LINES);
	    glVertex3f(value, -1, 0);
	    glVertex3f(value, +1, 0);
	    glVertex3f(-1, value, 0);
	    glVertex3f(+1, value, 0);
	    glEnd();
	}

	if (zAxis == true){
	    glBegin(GL_LINES);
	    glVertex3f(0, 0, -1);
	    glVertex3f(0, 0, +1);
	    glEnd();
	}
	    
	
	if (iMode == GL_COMPILE || iMode == GL_COMPILE_AND_EXECUTE)
	    glEndList(); 
	
	return listName;
    }
    
}
