
#ifndef _POV_VELOCITY_COMMON_H_
#define _POV_VELOCITY_COMMON_H_

#include "../clsPovSerialize.h"
#include "../../CONFITEM/clsConfItem.h"

class MultiNumericalInputs_cls;
class PovVelocityDataCommon_cls;

class PovVelocityCommonInterp_cls{
 public:
    int mOffsetZ, mOffsetY;

    float GetInterpolatedValue(const unsigned char *pData,
			       const int lBaseIndex,
			       const float fx, const float fy, const float fz);
};

class PovVelocityGUICommon_cls{
 public:
    PovVelocityGUICommon_cls();

    PovVelocityDataCommon_cls *mpCDataCommon;
    
    MultiNumericalInputs_cls *mpCMNumCustomA;
    wxRect mCRectMNumCustomA;
    void SetMNumCustomA(wxWindow *pCParentWindow);
};

class PovVelocityDataCommon_cls {
 public:
    ConfItemUINT_cls mCCompX;
    ConfItemUINT_cls mCCompY;
    ConfItemUINT_cls mCCompZ;
};

class PovVelocityCommon_cls : public PovSerialize_cls {
 public:
    int mSizeX, mSizeY, mSizeZ;
    
    wxString GetPovStrPeriodicOffset();
};

#endif
