// -*- c -*- 
// "clsButtonEX.h"

#include "clsButtonEX.h"

wxButtonEX::
wxButtonEX(wxWindow* parent, wxWindowID id, const wxString& label,
	   const wxPoint& pos, const wxSize& size,
	   long style, const wxValidator& validator,
	   const wxString& name) :
    wxButton(parent, id, label, pos, size, style, validator, name)
{
    Connect(id, wxEVT_KEY_DOWN,
	    wxKeyEventHandler(wxButtonEX::OnKeyDown));
    /*
    Connect(GetId(), wxEVT_LEFT_DOWN,
	    wxMouseEventHandler(wxButtonEX::OnMouse));
    */
    Connect(GetId(), wxEVT_RIGHT_DOWN,
	    wxMouseEventHandler(wxButtonEX::OnMouse));
}

wxWindow* wxButtonEX::
GetPWindow(){
    return this;
}

void wxButtonEX::
OnKeyDown(wxKeyEvent& event){
    ProcessKeyEvent(event);
}

void wxButtonEX::
OnMouse(wxMouseEvent& event){
    GetParent()->AddPendingEvent(event);
    event.Skip();
}
