// -*- c -*- 
// "clsAtoSTextCtrl.cpp"

#ifndef _ATOWXS_TEXT_CTRL_H_
#define _ATOWXS_TEXT_CTRL_H_

#include <wx/wx.h>
#include "EX/clsTextCtrlEX.h"
#include "EX/clsButtonEX.h"

#include <string>

class AtoWXSTextCtrl_cls 
: public TextCtrlEX_cls {
 public:
    AtoWXSTextCtrl_cls(wxWindow *parent, wxWindowID id, wxString strInit,
		       wxPoint pos = wxDefaultPosition,
		       wxSize size = wxSize(40, -1),
		       long style = 0, 
		       const wxValidator& validator = wxDefaultValidator);
    
    void UpdateValueFromText(/*bool assign = FALSE*/);

    void UpdateDisplay();
    wxString GetWXStr();
    void SetValueWXStr(wxString strValue);
    
    wxString mwsValue;

    void OnKillFocus(wxFocusEvent& event);
};

class AtoWXSTextPathCtrl_cls
: public wxPanel {
 public:
    AtoWXSTextPathCtrl_cls(wxWindow *parent, wxWindowID id, wxString strInit,
			   wxPoint pos = wxDefaultPosition,
			   wxSize size = wxDefaultSize,
			   long style = 0,
			   const wxValidator& validator = wxDefaultValidator);
    ~AtoWXSTextPathCtrl_cls();

    AtoWXSTextCtrl_cls* mpCTextCtrl;
    wxButtonEX* mpCButton;
    wxString *mpstrDefaultDirLink;
    wxString mstrDefaultFileName;
    wxString mstrFilter;
    int mStyle;
    
    void UpdateValueFromText(/*bool assign = FALSE*/);

    void UpdateDisplay();
    wxString GetWXStr();
    void SetValueWXStr(wxString strValue);

    void OnButton(wxCommandEvent& event);
};

#endif
