// -*- c -*-
// "clsPendEventList.h"

#include "clsPendEventList.h"

void PendEventList_cls::
AddPendEventListIfnotExist(void **ppExistence, wxWindow* pItem, int type){
    for (unsigned int i = 0; i < mvpListToSend.size(); i++)
	if (mvpListToSend[i] == pItem) return;

    mvppListExistence.push_back(ppExistence);
    mvpListToSend.push_back(pItem);
    mvTypeListToSend.push_back(type);
}

void PendEventList_cls::
PendEventLists(){
    int deadWindow = -1;

    for (unsigned int i = 0; i < mvpListToSend.size(); i++){
	switch(mvTypeListToSend[i]){
	case _PEND_TYPE_CHILD_FOCUS: {
	    if (*mvppListExistence[i] != mvpListToSend[i]) {
		deadWindow = i;
		break;
	    }
	    wxChildFocusEvent dummyEvent;
	    mvpListToSend[i]->AddPendingEvent(dummyEvent);
	    break; }
	case _PEND_TYPE_SIZE: {
	    if (*mvppListExistence[i] != mvpListToSend[i]) {
		deadWindow = i;
		break;
	    }
	    wxSizeEvent dummyEvent;
	    mvpListToSend[i]->AddPendingEvent(dummyEvent);
	    break; }
	}
    }

    // $B;`$s$@%&%#%s%I%&$O:o=|(B
    if (deadWindow != -1){
	std::vector< void** >::iterator itppList = 
	    mvppListExistence.begin();
	std::vector< wxWindow* >::iterator itpListToSend = 
	    mvpListToSend.begin();
	std::vector < int >::iterator itTypeList = 
	    mvTypeListToSend.begin();
	
	mvppListExistence.erase(itppList      + deadWindow);
	mvpListToSend    .erase(itpListToSend + deadWindow);
	mvTypeListToSend .erase(itTypeList    + deadWindow);
    }
}
