
#ifndef _MULTITHREAD_CTRL_H_
#define _MULTITHREAD_CTRL_H_

#include <wx/wx.h>
#include <wx/thread.h>

#define _MAX_THREAD_NUM 16

class Preference_cls;

class MultiThreadThread_cls : public wxThread {
 public:
    MultiThreadThread_cls(wxThreadKind kind);

    void SetReadyFlag(bool *pbReadyFlag);

    bool *mpbReadyFlag;
};

class MultiThreadCtrl_cls {
 public:
    static Preference_cls *mspCPreferenceLink;
    int  mThreadNum;
    
    bool mbAThreadReady[_MAX_THREAD_NUM];
    void InitializeThreadCtrl();
    void WaitForThreadsAndRun(MultiThreadThread_cls *pCThread);
    
    void WaitAllThreadsEnd();
};

#endif
