// "clsDraw3DTexBoxA.cpp"

#ifndef _DRAW_3DTEXBOX_A_H_
#define _DRAW_3DTEXBOX_A_H_

#include "../../MYGL/clsPositionAndDirection.h"

#if WIN32
#include <windows.h>
#endif

#ifndef TRUE
#define TURE true
#define FALSE false
#endif

#include <vector>

class PreviewProperty_cls;
//class DF3Sequence_cls;
class DF3SeqCtrl_cls;

class DrawDataBoxBase_cls{
 public:
    //DF3Sequence_cls *mpCDF3SeqLink;
    DF3SeqCtrl_cls *mpCDF3SeqCtrlLink;
    PreviewProperty_cls *mpCPropertyLink;
    void SetBlendFunction();
};

class Draw3DTexBoxA_cls : public DrawDataBoxBase_cls {
 public:
    Draw3DTexBoxA_cls(DF3SeqCtrl_cls *pCDF3SeqCtrl, 
		      PreviewProperty_cls *pCProperty);
    
    static std::vector < std::vector < Position_cls > > mVVCIntersect; 

    void   CalcAllSlice(PositionAndDirection_cls CCam,
		      double clipBoxMin[3], double clipBoxMax[3]);
    void   CalcSingleSlice(PositionAndDirection_cls CCam, double basePos[3],
			 double clipBoxMin[3], double clipBoxMax[3]);
    
    void   DrawAllSlice(double alpha, float clr[3], float clrinv[3],
			double fogAlpha, bool bDrawVolume,
			double *pShadeOffset = NULL,
			bool bFrame = FALSE);
    void   DrawAllSliceWithOtherGL
	(double *Aalpha, int indexNum, int texFilter,
	 float (*clr)[3], float (*clrinv)[3], int *Atexture3D, 
	 double fogAlpha, bool *AbDrawVolume,
	 double *pShadeOffset = NULL, bool bFrame = FALSE);
    
    void   DrawSingleSlice(int index, double *pShadeOffset);
};

#endif
