// -*- c -*- 
// "clsResumableProgress.cpp"

#ifndef _RESUMABLE_PROGRESS_H_
#define _RESUMABLE_PROGRESS_H_

#include <time.h>

#define _RESUMABLE_ENABLE_RESUME FALSE
#define _RESUMABLE_FORCE_FINISH  TRUE

class ResumableProgress_cls{ 
 private:
    int  mDuration;
    bool mbFinished;
    bool mbInProgress;
    
    clock_t mStartClock;

 public:
    unsigned int mNext;
    unsigned int mMax;

 public:
    ResumableProgress_cls();

    void Clear();
    bool IsCleared();

    bool IsFinished();
    bool IsInProgress();
    virtual bool IsFinishConditionSatisfied();
    //virtual bool MainProcess(bool type);
    virtual 
    
    void Initialize(unsigned int max);
    bool IsResumeConditionSatisfied(bool type);
    void Finalize();
    
    int  GetPercent();
};

#endif
