
#ifndef _BOXCOPY_H_
#define _BOXCOPY_H_

class BoxCopy_cls;

#include "../CONFITEM/clsConfItem.h"
#include "../FILTER/clsFilterBase.h"
#include "../WIDGETCTRL/clsMultiNumericalInputs.h"

class BoxCopyGUI_cls : public FilterGUI_cls {
 public:
    //BoxCopyGUI_cls(BoxCopy_cls *pCParent);
    ~BoxCopyGUI_cls();

    MACRO_DefGUIMainSettings(BoxCopy);
    /*
    BoxCopy_cls *mpCParent;
    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      unsigned int index);
    */

    MultiNumericalInputs_cls *mpCMNumCustomA;
    wxRect mCRectMNumCustomA;
    void SetMNumCustomA(wxWindow *pCParentWindow);

    MACRO_DefVirtualCustmFunctions;

    void OpenCustomADialog();
};

class BoxCopyData_cls : public FilterData_cls {
 public:
    BoxCopyData_cls();

    void ReDefineList();
    ConfItemBOOLARRAY_cls  mCbMirroring;
    ConfItemBOOLARRAY_cls  mCbCopying;
    ConfItemINTARRAY_cls   mCCopyFrom;
    ConfItemINTARRAY_cls   mCCopyTo;

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
};

class BoxCopy_cls : public FilterBase_cls {
 public:
    BoxCopy_cls(FilterCtrl_cls *pCParentCtrl,
		BoxCopyData_cls *pCInitData = NULL);
    ~BoxCopy_cls();

    BoxCopyData_cls mCData;
    FilterData_cls*  GetPData();

    void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanel, unsigned int index);

    //--

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    
    static BoxCopyData_cls ReadDataBlock(std::wistream &istream);
};

#endif
