
#ifndef _FILTER_CLIPPING_H_
#define _FILTER_CLIPPING_H_

class FilterClippingData_cls;

//#include "clsPovSerialize.h"
#include "../CONFITEM/clsConfItem.h"
#include "../DF3/clsDF3SeqCtrl.h"
#include "../FILTER/clsFilterBase.h"
#include "../FILTER/clsFilterWithSelect.h"
#include "../FILTER/clsFilterWithParameter.h"
#include "../PARAMETER/clsParameters.h"

class DF3SeqGUI_cls;
class FilterClipping_cls;

#define _FILTER_TARGET_ALL 0

class FilterClippingGUI_cls : public FilterWithTargetGUI_cls {
 public:
    FilterClippingGUI_cls(FilterClipping_cls *pCParent);
    
    FilterClipping_cls *mpCParent;

    void SetMNumPanel(wxBoxSizer *pBoxSizer, wxWindow *pCParentWindow,
		      unsigned int index);
    MACRO_DefVirtualCustmFunctions;
};

class FilterClippingData_cls : public FilterWithParameterData_cls {
 public:
    FilterClippingData_cls(FilterCtrl_cls* pCCtrl, 
			   bool bConnectToStaticParam = TRUE);
    
    void ReDefineList();
    ConfItemSTR_cls   mCConfTargetStr;
    
    // |C^ĊmۂňړȂ悤ɂB(UNDO݂ł܂)
    // *todo _MAX_ITEM_NUMBERɂ鏈
    static std::vector < Parameters_cls > msVCParam[_DF3_MAX_SLOT]; // 
    static std::vector < bool > msVbParamUsed[_DF3_MAX_SLOT];
    static void InitializeStaticMember(int df3index);
    
    Parameters_cls* GetPParamActive();

    // UndoŁẢ\Parameter̊mۂSɕKvȂȂJB
    // !! Complete Me !!
    static void GarbageCollect();

    void MakeFilterInstanceAndAddToList
	(int index, FilterCtrl_cls *pCParentCtrl);
    wxString SerializeConfPolymorph();
    void ReadStrLinePolymorph(std::wistream &istream, std::wstring strLine);
};


class FilterClipping_cls : public FilterWithParameter_cls {
 public:
    FilterClipping_cls(FilterCtrl_cls *pCParentCtrl,
		       FilterClippingData_cls *pCInitData = NULL);
    ~FilterClipping_cls();
    
    void UpdateTarget();
    void UpdateTargetInfo();
    
    void SetMNumAdvanced(wxWindow *pCParentWindow);
    static  ConfItemBOOL_cls   msCConfClippingFollowTracking;
    
    //--
    virtual void AddFilterItemPolymorph(wxBoxSizer *pBoxSizer, FilterPanels_cls *pCFilterPanels, unsigned int index);
    static void InitializeStaticMember(int df3index);
    FilterClippingData_cls* GetPCData();
    //--

    //void DrawGLBox();

    //--

    wxString GetFilterStatusStr();
    wxString SerializeConf();
    static FilterClippingData_cls* 
	GetNewPReadDataBlock(FilterCtrl_cls* pCCtrl, 
			     std::wistream &istream);
};

#endif
