// -*- c -*- 
// "clsAliasBox.h"
// "../../wxWidgetEnum.h"
// (setq c-basic-offset 4)

#include "clsAliasBox.h"

AliasBox_cls::
AliasBox_cls(){    
    mbDraw = FALSE;
    mBoxType = _ABOX_8BOX;
}

void AliasBox_cls::
DrawCube(){
    glColor4f(1.f, 1.f, 0.5f, 0.01f);
    glBegin(GL_QUADS);
    glVertex3d(0, 0, 0); glVertex3d(1, 0, 0);
    glVertex3d(1, 1, 0); glVertex3d(0, 1, 0);
	
    glVertex3d(0, 0, 1); glVertex3d(1, 0, 1);
    glVertex3d(1, 1, 1); glVertex3d(0, 1, 1);
    glEnd();

    glColor4f(1.f, 0.5f, 1.f, 0.01f);
    glBegin(GL_QUADS);
    glVertex3d(0, 0, 0); glVertex3d(0, 1, 0);
    glVertex3d(0, 1, 1); glVertex3d(0, 0, 1);

    glVertex3d(1, 0, 0); glVertex3d(1, 1, 0);
    glVertex3d(1, 1, 1); glVertex3d(1, 0, 1);
    glEnd();
	
    glColor4f(0.5f, 1.f, 1.f, 0.01f);
    glBegin(GL_QUADS);
    glVertex3d(0, 0, 0); glVertex3d(1, 0, 0);
    glVertex3d(1, 0, 1); glVertex3d(0, 0, 1);

    glVertex3d(0, 1, 0); glVertex3d(1, 1, 0);
    glVertex3d(1, 1, 1); glVertex3d(0, 1, 1);
    glEnd();
    
}

void AliasBox_cls::
DrawFrame(){
    if (mbDraw == FALSE) return;

    glTranslated(-0.5, -0.5, -0.5);
    //glDisable(GL_DEPTH_TEST);

    switch(mBoxType){
    case _ABOX_4BOX: 
	DrawCube();
	glBegin(GL_QUADS);
	glVertex3d(0.5, 0, 0); glVertex3d(0.5, 1, 0);
	glVertex3d(0.5, 1, 1); glVertex3d(0.5, 0, 1);
	
	glVertex3d(0, 0.5, 0); glVertex3d(1, 0.5, 0);
	glVertex3d(1, 0.5, 1); glVertex3d(0, 0.5, 1);
	glEnd();
	break;
    case _ABOX_8BOX:
	DrawCube();
	glColor4f(1.0f, 1.f, 1.f, 0.01f);
	glBegin(GL_QUADS);
	glVertex3d(0, 0, 0.5); glVertex3d(1, 0, 0.5);
	glVertex3d(1, 1, 0.5); glVertex3d(0, 1, 0.5);
	
	glVertex3d(0.5, 0, 0); glVertex3d(0.5, 1, 0);
	glVertex3d(0.5, 1, 1); glVertex3d(0.5, 0, 1);
	
	glVertex3d(0, 0.5, 0); glVertex3d(1, 0.5, 0);
	glVertex3d(1, 0.5, 1); glVertex3d(0, 0.5, 1);
	glEnd();
	break;
    }
    
    glTranslated(+0.5, +0.5, +0.5);
}
    
    

