// -*- c -*-
// "clsFileSearch.h"

#include "clsFileSearch.h"
#include <fstream>

#include "../MYAPI/MsgBox.h"

#ifndef TRUE
#define TRUE  true
#define FALSE false
#endif

FileSearch_cls::
FileSearch_cls() : mCFile()
{
    mIndex = 0;
}

int FileSearch_cls::
GetSequencialIndex(std::string strFilePath){
    mIndex = 0;
    mCFile.Set(strFilePath);
    int mIncrement = 1000;

    std::fstream ifstream;
	
    bool exitFlag = FALSE;
    while (TRUE){
	FileSequence_cls CInc;
	do {
	    if (mIncrement == 1) { // increment1$B$+$i7+$j2<$2$J$i=*N;(B
		exitFlag = TRUE; break;
	    }
	    mIncrement = mIncrement / 10;
	    CInc = mCFile;
	    CInc.GetFormat(); // $BO"HV$N7e?t$b7W;;(B
	    CInc.Increment(_FN_INCREMENT_TAIL, mIncrement);
	    ifstream.clear();
	    
	    if (CInc == mCFile)
		ifstream.clear(std::ios::badbit);
	    else
		ifstream.open(CInc.GetPathStr().c_str(), std::ios::in);
	    
	    if (!ifstream.fail()) ifstream.close();
	} while (ifstream.fail()); // $B%U%!%$%k$,L5$1$l$P(Bincrement$B$r7+$j2<$2$k(B
	
	mCFile = CInc;
	mIndex += mIncrement;
	if (exitFlag == TRUE) break;
	mIncrement *= 10;
    }
    
    return mIndex;
}

bool operator==(const Filename_cls& CLeft,
		const Filename_cls& CRight){
    return (CLeft.mSPath == CRight.mSPath);
}
