// (setq c-basic-offset 4)
// "clsFilterPanelPain.h"

#include "../../clsFrameMain.h"
#include "../../wxWidgetEnum.h"
#include "../FILTER/clsFilterCtrl.h"
#include "../GLCANVAS/clsGLCanvasCtrl.h"
#include "../GLCANVAS/clsMainGLCanvas.h"
#include "clsFilterPanelPain.h"

#include "../MYAPI/MsgBox.h"

// ÓIɃCxgт
BEGIN_EVENT_TABLE(FilterPanelPain_cls, wxScrolledWindow)
EVT_MOUSE_EVENTS(FilterPanelPain_cls::OnMouse)
EVT_NOTEBOOK_PAGE_CHANGED(ID_BOOK_DATASLOT, FilterPanelPain_cls::OnPageChanged)
//     EVT_KEY_DOWN(PreviewPanel_cls::OnKeyDown)
END_EVENT_TABLE()

wxColour FilterPanelPain_cls::msColourActive[4] = 
{wxColour(255, 32, 32), wxColour(32, 255, 32), wxColour(32, 64, 255), wxColour(255, 255, 255)};
wxColour FilterPanelPain_cls::msColourInactive[4] = 
{wxColour(164, 96, 96), wxColour(96, 164, 96), wxColour(64, 64, 164), wxColour(164, 164, 164)};

FilterPanelPain_cls::
FilterPanelPain_cls(wxWindow *pC, FrameMain_cls *pCFrame) : 
wxScrolledWindow(pC, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxVSCROLL )
{
    SetScrollbars(0, 5, 0, 50);
    EnableScrolling(FALSE, TRUE);
    mpCParentFrame = pCFrame;

    mpCBook = new wxNotebook(this, ID_BOOK_DATASLOT,
			     wxDefaultPosition, wxSize(-1, 999));

    for (int i = 0; i < _DF3_MAX_SLOT; i++){
	//mpBoxSizerData[i] = new wxBoxSizer (wxVERTICAL);
	mpCFilterPanels[i] = new FilterPanels_cls(mpCBook/*this*/, pCFrame);
    }

    /*
    mpCFilterPanels[0]->SetBackgroundColour(msColourActive[0]);
    mpCFilterPanels[1]->SetBackgroundColour(msColourInactive[1]);
    mpCFilterPanels[2]->SetBackgroundColour(msColourInactive[2]);
    mpCFilterPanels[3]->SetBackgroundColour(msColourInactive[3]);
    */

    wxBoxSizer  *pCBoxSizerSRC = new wxBoxSizer(wxVERTICAL);

    pCBoxSizerSRC->Add(220 + 8, 0, 0); // _
    
    mpCParentFrame->SetMNumBoxInformation(pCBoxSizerSRC, this);
    mpCParentFrame->SetMNumPlayOption    (pCBoxSizerSRC, this);

    mpCBook->AddPage(mpCFilterPanels[0], wxT("Data0"));
    //mpCBook->SetSizer(mpCFilterPanels[0]->mpBoxSizer);

    mpCBook->AddPage(mpCFilterPanels[1], wxT("Data1"));
    //mpCBook->SetSizer(mpCFilterPanels[1]->mpBoxSizer);

    mpCBook->AddPage(mpCFilterPanels[2], wxT("Data2"));
    //mpCBook->SetSizer(mpCFilterPanels[2]->mpBoxSizer);

    mpCBook->AddPage(mpCFilterPanels[3], wxT("Data3"));
    //mpCBook->SetSizer(mpCFilterPanels[3]->mpBoxSizer);

    pCBoxSizerSRC->Add(mpCBook, 0, wxEXPAND);

    /*
    for (int i = 0; i < _DF3_MAX_SLOT; i++)
	pCBoxSizerSRC->Add(mpCFilterPanels[i], 0, wxEXPAND);
    */

    this->SetSizer(pCBoxSizerSRC);
}

FilterPanelPain_cls::
~FilterPanelPain_cls(){
    /*
    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++)
	delete mpCFilterPanels[df3];
    */
}

void FilterPanelPain_cls::
RefreshBG(int activedataslot){
    /*
    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++){
	if (activedataslot == df3)
	    mpCFilterPanels[df3]->SetBackgroundColour(msColourActive[df3]);
	else
	    mpCFilterPanels[df3]->SetBackgroundColour(msColourInactive[df3]);
	mpCFilterPanels[df3]->ClearBackground();
    }
    */
}

void FilterPanelPain_cls::
RefreshPanels(){
    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++)
	mpCFilterPanels[df3]->RefreshPanels();
	
    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++)
	mpCFilterPanels[df3]->Layout();

    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++)
	mpCFilterPanels[df3]->Refresh();

    mpCBook->Refresh();

    Layout();
}

void FilterPanelPain_cls::
ProcessEventOnStack(){
    for (int df3 = 0; df3 < _DF3_MAX_SLOT; df3++)
	mpCFilterPanels[df3]->ProcessEventOnStack();
}

void FilterPanelPain_cls::
OnMouse(wxMouseEvent& event){
    if (event.GetId() == GetId()){
	if (event.RightDown() == TRUE)
	    mpCParentFrame->PopupMenu(mpCParentFrame->mpCMenuFilter, wxDefaultPosition);
	if (event.LeftDown() == TRUE)
	    mpCParentFrame->DeselectAllIf(wxT(""));
    }
    
    event.Skip();
}

void FilterPanelPain_cls::
OnPageChanged(wxNotebookEvent& event){
    int selection = event.GetSelection();
    mpCParentFrame->mpCDF3SeqCtrl->mCConfActiveSlot.mBody = selection;
}
