
#ifndef _FILTER_PANEL_PAIN_H_
#define _FILTER_PANEL_PAIN_H_

#include <wx/wx.h>
#include <wx/notebook.h>
#include <list>

#include "clsFilterPanels.h"
#include "../DF3/clsDF3SeqCtrl.h"

class FrameMain_cls;
class FilterPanels_cls;
class wxNotebook;

class FilterPanelPain_cls : public wxScrolledWindow {
 public:
    FilterPanelPain_cls(wxWindow *pC, FrameMain_cls *pCFrame);
    ~FilterPanelPain_cls();

    static wxColour msColourActive[4], msColourInactive[4];

    FrameMain_cls *mpCParentFrame;
    wxNotebook    *mpCBook;
    FilterPanels_cls* mpCFilterPanels[_DF3_MAX_SLOT];
    //wxBoxSizer    *mpBoxSizerData[_DF3_MAX_SLOT];

    void RefreshBG(int activedataslot);
    void RefreshPanels();
    void ProcessEventOnStack();
    void OnMouse(wxMouseEvent& event);
    void OnPageChanged(wxNotebookEvent& event);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
