
#ifndef _PREVIEW_PANEL_H_
#define _PREVIEW_PANEL_H_

#include <wx/wx.h>
#include <wx/splitter.h>
#include <list>

#include "clsFilterPanels.h"
#include "../DF3/clsDF3SeqCtrl.h"

class FrameMain_cls;
//class FilterPanels_cls;
//class FilterPanelPain_cls;

//#define _PREVIEW_FILTER_OFFSET 7

class PreviewPanel_cls : public wxPanel {
 public:
    PreviewPanel_cls(wxWindow *pC, FrameMain_cls *pCFrame);
    ~PreviewPanel_cls();

    FrameMain_cls *mpCParentFrame;
    //FilterPanels_cls* mpCFilterPanels[_DF3_MAX_SLOT];
    
    wxSplitterWindow* mpCSplitterMain;
    wxSplitterWindow* mpCSplitterChildA;
    wxSplitterWindow* mpCSplitterChildB;

    void SplitPanel(unsigned int type);

    //std::list < ItemIntAndPointer_cls > mPanelListItem;

    //void RefreshPanels();

    void OnMouse(wxMouseEvent& event);
    
    //void OnKeyDown(wxKeyEvent &event);

 private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

#endif
